2007-12-31  Dave Beckett <dave@dajobe.org>

	* src/raptor_iostream.c: (raptor_iostream_init_common): Added to
	init iostream fields

	* src/raptor_iostream.c: Replaced raptor_iostream_handler
	structure with raptor_iostream_handler2
	(raptor_new_iostream_from_handler2): Added.
	(raptor_new_iostream_from_handler): Rewritten to use
	raptor_new_iostream_from_handler2 and create an internal
	raptor_iostream_handler2.
	(raptor_new_iostream_from_sink, raptor_new_iostream_from_filename
	raptor_new_iostream_from_file_handle,
	raptor_new_iostream_from_string): Added for constructing read
	iostreams.
	(method raptor_iostream_read_bytes): Added for reading from read
	iostreams.


	* src/raptor.h: Added raptor_iostream_read_bytes_func Added
	raptor_iostream_handler2 with version, private field and
	read_bytes field.  Deprecated raptor_iostream_handler structure
	for raptor_iostream_handler2 structure.  Added
	raptor_new_iostream_from_handler2 and deprecated
	raptor_new_iostream_from_handler Added
	raptor_new_iostream_from_sink, raptor_new_iostream_from_filename
	raptor_new_iostream_from_file_handle and
	raptor_new_iostream_from_string for constructing read iostreams.
	Added method raptor_iostream_read_bytes for read iostreams.

2007-12-28  Dave Beckett <dave@dajobe.org>

	* src/raptor.h, src/raptor_internal.h: Move SAX2 to public
	API. Added new raptor_sax2 typedef.  Added XML type handlers
	raptor_sax2_start_element_handler,
	raptor_sax2_end_element_handler, raptor_sax2_characters_handler,
	raptor_sax2_cdata_handler, raptor_sax2_comment_handler,
	raptor_sax2_unparsed_entity_decl_handler,
	raptor_sax2_external_entity_ref_handler.  Added functions
	raptor_new_sax2, raptor_free_sax2,
	raptor_sax2_set_start_element_handler,
	raptor_sax2_set_end_element_handler,
	raptor_sax2_set_characters_handler, raptor_sax2_set_cdata_handler,
	raptor_sax2_set_comment_handler,
	raptor_sax2_set_unparsed_entity_decl_handler,
	raptor_sax2_set_external_entity_ref_handler,
	raptor_sax2_set_namespace_handler, raptor_sax2_parse_start,
	raptor_sax2_parse_chunk, raptor_sax2_parse_handle_errors,
	raptor_sax2_inscope_xml_language, raptor_sax2_inscope_base_uri
	Moved log API to public API. Added raptor_log_level and
	raptor_error_handlers typedefs.  Added
	raptor_error_handlers_init.

	* src/raptor.h, src/raptor_xml.c: Added
	raptor_xml_element_get_language

	* src/raptor.h, src/raptor_qname.c: Added
	raptor_qname_get_local_name and raptor_qname_get_value

	* src/raptor_turtle_writer.c: cast

	* src/raptor_xml_writer.c: cast

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_newline): Cast
	for signed/unsigned int compare.

	* src/raptor_xml_writer.c: (raptor_xml_writer_indent): Cast for
	signed/unsigned int compare.

	* tests/turtle/Makefile.am: Add bad-19.ttl

	* tests/turtle/bad-19.ttl: bad-19 () in predicate position

2007-12-24  Dave Beckett <dave@dajobe.org>

	* docs/raptor.types: Add gtkdoc file raptor.types

2007-12-19  Lauri Aalto <laalto@iki.fi>

	* src/raptor_stringbuffer.c: (raptor_new_stringbuffer) Fixed
	docs. Removed unnecessary local var and conditional.

2007-12-18  Lauri Aalto <laalto@iki.fi>

	* src/turtle_parser.y: (raptor_trig_parse_recognise_syntax): Wrap
	function in #ifdef RAPTOR_PARSER_TRIG. Used only if
	RAPTOR_PARSER_TRIG is defined, avoids gcc warning on unused static
	function.

2007-12-13  Lauri Aalto <laalto@iki.fi>

	* src/raptor_uri.c: Portability: Use Windows-like path handling on
	Symbian.

2007-12-09  Dave Beckett <dave@dajobe.org>

	* docs/raptor-tutorial-parsing.xml: fix raptor_set_feature() call
	to have 3 args

2007-11-28  Dave Beckett <dave@dajobe.org>

	* tests/turtle/Makefile.am, tests/turtle/bad-17.ttl,
	tests/turtle/bad-18.ttl, tests/turtle/manifest-bad.ttl: bad tests
	17 and 18 to Forbid ' and '''-quoted strings

	* src/turtle_lexer.l: Remove '-quoted strings

2007-11-26  Dave Beckett <dave@dajobe.org>

	* autogen.sh: Update to handle OSX glibtoolize and optional ltdl

2007-11-15  Lauri Aalto <laalto@iki.fi>

	* src/raptor_sax2.c: (raptor_sax2_parse_chunk) Fix compiler
	warnings: unused variable, unused label.

2007-11-15  Dave Robillard <dave@drobilla.net>

	* src/raptor_serialize_turtle.c:
	(raptor_turtle_emit_subject_properties): Write ; statement
	terminators with a leading space for consistency with . terminator

2007-11-12  Lauri Aalto <laalto@iki.fi>

	* src/raptor_www.c: (raptor_www_init) Pull static initialized flag
	from function scope to unit scope.

	* src/raptor_nfc.h, src/raptor_nfc_data.c: Make raptor nfc data
	const - eliminate ~53768 bytes of writable static.

	* src/raptor_serialize_rss.c: Make raptor_rss10_spaces pointer const.

	* src/n3_parser.y, src/raptor.h, src/raptor_internal.h,
	src/raptor_namespace.c, src/raptor_rdfxml.c, src/raptor_rss.c,
	src/raptor_sax2.c, src/raptor_serialize_dot.c,
	src/raptor_serialize_rdfxml.c, src/raptor_serialize_rdfxmla.c,
	src/raptor_serialize_rss.c, src/raptor_serialize_turtle.c,
	src/raptor_turtle_writer.c, src/raptor_uri.c,
	src/raptor_xml_writer.c, src/turtle_parser.y: Make
	raptor_uri_handlers const. SOURCE COMPATIBILITY BREAK: Five raptor
	API function signatures changed:
	raptor_uri_set_handler()
	raptor_uri_get_handler()
	raptor_new_namespaces()
	raptor_namespaces_init()
	raptor_new_xml_writer()

	* src/raptor_uri.c: (raptor_uri_set_handler) Assert inputs

2007-11-06  Lauri Aalto <laalto@iki.fi>

	* src/raptor_serialize_turtle.c: fix eol style

	* src/raptor_uri.c: (raptor_uri_set_handler) Treat uri handler as
	const although the API does not say it is const.

	* src/raptor.h: Allow RAPTOR_API to be externally defined e.g. in
	a static config.h. Remove __SYMBIAN32__ case.

	* src/turtle_lexer.l, src/turtle_parser.y: Rename
	turtle {TRUE,FALSE} tokens to {TRUE,FALSE}_TOKEN to prevent
	potential clashes with system headers.

	* src/raptor_turtle_writer.c, src/raptor_xml_writer.c: Remove
	writable static data. Refactor turtle/xml writers to use a const
	spaces_buffer.

	* src/raptor_uri.c: Remove writable static data. Make
	raptor_uri_handler const

	* src/ntriples_parse.c, src/raptor_feature.c,
	src/raptor_general.c: Remove writable static data. Make const
	arrays const.

2007-11-05  Lauri Aalto <laalto@iki.fi>

	* src/raptor_serialize_turtle.c: (raptor_turtle_serialize_init)
	Fix lowmem issues: Do not use a NULL namespaces sequence or
	nstack.  NULL rdf_type is allowed.  Check for uri creation
	failures.  Check for sequence push failures.
	(raptor_turtle_serialize_terminate) Do not leave dangling pointers
	behind.

2007-11-04  Dave Beckett <dave@dajobe.org>

	* src/raptor_turtle_writer.c: (main): Write a proper double

	* tests/turtle/test-28-out.ttl: Remove canonicalisation

	* src/raptor_serialize_turtle.c: (raptor_turtle_emit_blank,
	raptor_turtle_emit_subject, raptor_turtle_emit): Add more failure
	pass ons.

	* src/raptor_serialize_turtle.c: (raptor_turtle_emit_subject):
	Fail when out of memory.

	* src/raptor_serialize_turtle.c: (raptor_turtle_emit_subject):
	Remove un-necessary use of snprintf to concat 2 strings.

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_double):
	Removed, no longer used.

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_literal): Do
	not canonicalise integer, double or decimal literals.

2007-10-31  Dave Beckett <dave@dajobe.org>

	* tests/turtle/test-10.out, tests/turtle/test-21.out,
	tests/turtle/test-22.out: Remove canonicalisation of integer and
	double (Turtle spec change coming soon)

2007-10-30  Lauri Aalto <laalto@iki.fi>

	* src/turtle_parser.y: Add {INTEGER,FLOATING}_LITERAL %destructors.

2007-10-30  Dave Beckett <dave@dajobe.org>

	* src/turtle_lexer.l, src/turtle_parser.y: Turtle INTEGER_LITERAL
	and FLOATING_LITERAL now are stored as strings, with no
	canonicalisation.  This is required for SPARQL compatibility.

2007-10-25  Lauri Aalto <laalto@iki.fi>

	* src/n3_parser.y: (blank) Fix [ propertylist ] lowmem leaks.

	* src/turtle_parser.y: (blank) Fix [ propertylist ] lowmem leaks.

2007-10-25  Dave Beckett <dave@dajobe.org>

	* src/snprintf.c: Define round() and trunc() as macros if they
	were not found by configure as functions/macros.  They were
	standardised with C99.

	* configure.ac: Check for trunc and round in libm

	* utils/rapper.c: Quote args to HELP_ARG_BOTH()

2007-10-24  Lauri Aalto <laalto@iki.fi>

	* src/turtle_parser.y: Add destructors for turtle_parser
	identifiers and sequences.
	(triples) Free subject and propertylist on alloc failure.

	* src/turtle_lexer.l: turtle_lexer: Check for alloc failures -
	fail faster and do not pass NULLs to parser.

2007-10-23  Lauri Aalto <laalto@iki.fi>

	* src/turtle_lexer.l: (QUOTEDURI) Always free stringbuffer

	* src/turtle_lexer.l: turtle_lexer: Check for alloc failures

	* src/n3_lexer.l: (n3_copy_string_token) Always free stringbuffer
	if it is allocated.

	* src/raptor_stringbuffer.c: (raptor_stringbuffer_append_string_common)
	Free passed in string on alloc error if ownership was transferred.

	* src/turtle_common.c: (raptor_stringbuffer_append_turtle_string)
	Check for alloc failure.

	* src/fix-flex, src/n3_lexer.l, src/raptor_internal.h,
	src/turtle_lexer.l: Lowmem leak fixes. Ported experimental lexer
	leak prevention code from sparql_lexer r12922 to
	raptor {n3,turtle}_lexer. Flagged with LEXER_ALLOC_TRACKING,
	disabled by default.
	(raptor_parser_s) Added lexer_user_data.

	* src/raptor_internal.h,
	src/raptor_parse.c: (raptor_parse_uri_with_connection) Lowmem leak
	fixes. Store raptor_www pointer to raptor parser object to allow
	resource cleanup from client code in case raptor_parse_chunk()
	fails in a lexer.

	* src/n3_parser.y,
	src/raptor_parse.c: (raptor_parse_uri_with_connection) Set parser
	to failed state if raptor_parse_chunk() returned an error.
	(raptor_n3_parse_chunk) Return error code from n3_parse().

2007-10-19  Lauri Aalto <laalto@iki.fi>

	* src/n3_lexer.l, src/turtle_lexer.l: (n3_lexer, turtle_lexer)
	Replace out-of-memory yyterminate()s with more informative error
	reporting.

	* src/fix-flex, src/n3_lexer.l, src/turtle_lexer.l: (fix-flex)
	Import patches from rasqal fix-flex: remove generated
	yy_fatal_error(), OOM checks to ensure_buffer_stack().
	(n3_lexer_fatal_error,turtle_lexer_fatal_error) Added replacement
	for generated fatal error handler.

	* src/n3_lexer.l: (QNAME) OOM: Terminate instead of returning NULL
	QNAME literal.

	* src/n3_parser.y: (n3_parser) PREFIX should not be in %destructor list

2007-10-18  Lauri Aalto <laalto@iki.fi>

	* src/fix-bison, src/fix-flex: (fix-bison, fix-flex) Fix #line
	numbers in generated raptor lexers and parsers.

2007-10-15  Lauri Aalto <laalto@iki.fi>

	* src/raptor_serialize_rdfxmla.c: (raptor_rdfxmla_serialize_statement)
	indent tabs -> spaces

	* src/raptor_serialize_rdfxmla.c: Fix low memory crashes.
	(raptor_rdfxmla_serialize_init) Check for nstack alloc failure
	before using it. Alloc independent objects in a batch and check
	them with one if. Check the return value of raptor_sequence_push()
	- moved to end since it depends on successful sequence allocation.
	(raptor_rdfxmla_serialize_terminate) Set pointers to NULL to
	prevent dangling pointers.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_init)
	Check sequence push ret val.

2007-10-12  Lauri Aalto <laalto@iki.fi>

	* src/raptor_sequence.c: (raptor_sequence_set_at) Free passed in
	data item also when returning due to invalid index.

2007-10-08  Dave Beckett <dave@dajobe.org>

	* src/raptor_internal.h, src/raptor_serialize_turtle.c,
	src/raptor_turtle_writer.c: (raptor_turtle_writer_literal,
	raptor_turtle_writer_quoted): These may fail when out of memory,
	change to return an int non-0 on failure

2007-10-06  Dave Beckett <dave@dajobe.org>

	* src/raptor_sequence.c: comments on sequence design

2007-10-05  Lauri Aalto <laalto@iki.fi>

	* src/raptor.h, src/raptor_sequence.c: (raptor_sequence_disown_at)
	Removed. Was a hack that should not be in a public API. Functions
	that needed this have been refactored to use
	raptor_sequence_unshift() to get the item and its ownership.

	* src/n3_parser.y: (propertyList) Refactored to not use
	raptor_sequence_disown_at()

	* src/turtle_parser.y: (propertyList) Refactored to not use
	raptor_sequence_disown_at()

	* src/raptor_sequence.c: Refactor raptor_sequence internals to
	make shift/unshift as efficient as push/pop.
	(raptor_free_sequence) Use RAPTOR_FREE macro instead of free() for
	sequence.
	(raptor_sequence_ensure) Added grow_at_front flag to describe
	growth direction.  Do not grow sequence if seq->capacity ==
	capacity.  Use RAPTOR_CALLOC instead of calloc() for sequence.
	(raptor_sequence_grow) Removed.
	(raptor_sequence_set_at) Do not allow setting items over +1
	current size.
	(main) Added test code.

2007-10-04  Lauri Aalto <laalto@iki.fi>

	* src/turtle_parser.y: Memory leak fixes: Free allocated resources
	and YYERROR on alloc failure.
	(raptor_turtle_new_triple) Free identifiers on error.

	* src/turtle_parser.y: (turtle_parse) Check lexer init return
	value.
	(raptor_turtle_parse_init) Return error code on failure.

	* src/raptor_identifier.c: (raptor_copy_identifier) Return
	non-zero on allocation failure. No need to check for non-null
	uris: raptor_uri_copy returns NULL if passed in a null
	uri. Removed duplicate copying of literal_language.

	* src/turtle_parser.y: (triples, propertyList, literal, blank)
	YYERROR on alloc failure.
	(raptor_turtle_parse_terminate) Free uris only if not null.

	* src/n3_parser.y: Memory leak fixes: free resources on error.
	(verb, literal, resource, blank, collection) Additional checks for
	alloc failures.

	* src/n3_lexer.l: lexer: yyterminate() on alloc failure.
	(n3_copy_token, n3_copy_string_token) Check for alloc failure.

	* src/raptor.h, src/raptor_sequence.c: Add raptor_sequence_disown_at()

2007-10-02  Lauri Aalto <laalto@iki.fi>

	* src/n3_parser.y: %destructors for %tokens and not just %types.
	(directive) YYERROR if namespace alloc failed.

2007-10-02  Dave Beckett <dave@dajobe.org>

	* NEWS.html, configure.ac, src/win32_raptor_config.h: Bumped
	version to 1.4.17

2007-10-01  Lauri Aalto <laalto@iki.fi>

	* src/raptor_identifier.c: (raptor_new_identifier) Free owned
	items on alloc failure.

	* src/n3_parser.y: (raptor_n3_new_triple) Free owned identifiers
	on alloc error.
	(n3_parse) Check lexer init return value.

	* src/n3_parser.y: n3 parser YYERROR on alloc failure. Still leaks
	memory on errors.

	* src/n3_parser.y: n3 parser YYERROR on alloc failure.

	* src/raptor_serialize_rdfxml.c: Fix indent + trim whitespace

2007-09-30  Dave Beckett  <dave@dajobe.org>

	* Snapshotted raptor_1_4_16 for 1.4.16 release (SVN 12743)

	* docs/libraptor.3: Fix functions using raptor_unichar
	GRDDL 2007-09-11

2007-09-29  Dave Beckett <dave@dajobe.org>

	* docs/libraptor.3: Added
	raptor_new_xml_element_from_namespace_local_name

	* src/raptor.h, src/raptor_serialize_rdfxml.c, src/raptor_xml.c:
	Alter raptor_new_xml_element_from_namespace_local_name signature
	to take an xml_language parameter

	* src/raptor_grddl.c: (raptor_grddl_run_recursive): Only set
	content type handler when recursive parser is grddl.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_end):
	Make sure an empty legal RDF/XML document is written when 0
	triples were serialized.

	* src/raptor_grddl.c: Replaced all calls to get parser's current
	base ID with raptor_parser_get_current_base_id

	* src/raptor_guess.c: (raptor_guess_get_current_base_id): Pass on
	the call to get the base ID to the internal parser using
	raptor_parser_get_current_base_id

	* src/raptor_internal.h,
	src/raptor_parse.c: (raptor_parser_get_current_base_id): Added.

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Remove
	#ifdef-out old <link> processing

	* src/raptor_grddl.c: (raptor_grddl_ensure_internal_parser):
	Re-init the guess parser each time so it does a fresh guess.
	(raptor_grddl_run_grddl_transform_doc): Save and restore the genid
	around recursive parsers, so blank nodes are numbered across
	graphs.
	(raptor_grddl_run_recursive): Switch to parser_name, flags args.
	Pass on the filter to the internal parser call.  Do not add parent
	if the parser is not grddl.  Pass on the ignore error flag to
	raptor_grddl_fetch_uri.  Save and restore the genid around
	recursive parsers, so blank nodes are numbered across graphs.  Do
	not call rdfxml parser if selected parser is already rdfxml.
	Update raptor_grddl_run_recursive calls to use parser name and
	flags.  Alter the <link> processing to use the guess parser to
	figure out the mime type during the recursion.  Do not filter the
	triples.
	Fixes Issue#0000238 http://bugs.librdf.org/mantis/view.php?id=238

	* src/raptor_www.c: (raptor_www_file_handle_fetch): Ensure the
	buffer has a NUL after the last byte read, it helps elsewhere when
	using str*() functions on the results - such as guessing the
	parser from content.

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Use
	RAPTOR_LIBXML_HTML_PARSE_NONET to decide whether to enable libxml
	HTML_PARSE_NONET with the html parser.

	* configure.ac: Add test for libxml HTML_PARSE_NONET since it not
	a define, it cannot be done at run-time with #ifdef
	Define RAPTOR_LIBXML_HTML_PARSE_NONET if available

	* src/raptor_grddl.c: Add declaration for libxml_options

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Use
	RAPTOR_LIBXML_XML_PARSE_NONET to set XML nonet option if it was
	set with raptor feature nonet.

	* tests/grddl/test-01.html: lie about the mime type in order to
	get the test to work

	* src/raptor_grddl.c: (raptor_grddl_uri_xml_parse_bytes): Use
	RAPTOR_LIBXML_XML_PARSE_NONET to check for enum value
	XML_PARSE_NONET

	* src/raptor_sax2.c: (raptor_sax2_parse_chunk): Use
	RAPTOR_LIBXML_XML_PARSE_NONET to check for XML_PARSE_NONET enum
	value.

	* tests/grddl/Makefile.am: Call rapper with -f noNet to prevent
	unnecessary fetches of HTML DTDs

	* configure.ac: Add test for libxml XML_PARSE_NO_NET since it not
	a define, it cannot be done at run-time with #ifdef
	Define RAPTOR_LIBXML_XML_PARSE_NONET if available

	* src/raptor_grddl.c: (raptor_grddl_fetch_uri): Reject a URI with
	feature noNet only if it is not a file URI

	* configure.ac, tests/Makefile.am, tests/grddl,
	tests/grddl/Makefile.am, tests/grddl/data-01.nt,
	tests/grddl/data-01.rdf, tests/grddl/data-02.rdf,
	tests/grddl/test-01.html, tests/grddl/test-01.out: Added
	tests/grddl dir and test-01

	* AUTHORS: Added Lauri Aalto

2007-09-27  Lauri Aalto <laalto@iki.fi>

	* src/n3_parser.y: (raptor_n3_parse_terminate) Do not assume the
	parser is fully initialized.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_ensure_writen_header,
	raptor_rdfxml_serialize_statement) Memory leak fixes: make sure
	base_uri is freed.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_ensure_writen_header)
	Memory leak fix. Set context->written_header flag early to prevent
	running the function again when a previous call to this function
	failed.

	* src/raptor_uri.c: (raptor_uri_to_relative_counted_uri_string)
	Fix memory leak - free uri details if suffix allocation fails.

2007-09-26  Dave Beckett <dave@dajobe.org>

	* autogen.sh: Added an inline perl script to grep out the version
	from programs.

2007-09-26  Lauri Aalto <laalto@iki.fi>

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_statement)
	Skip statements with bad predicate uris, do not return an error.

	* src/raptor_uri.c: (raptor_default_new_uri,
	raptor_uri_path_make_relative_path,
	raptor_uri_to_relative_counted_uri_string,
	raptor_uri_uri_string_to_filename_fragment) Check for alloc
	failures.

	* src/raptor_serialize_rdfxml.c:
	(raptor_rdfxml_serialize_statement) Make sure
	xml_writer->current_element does not become a dangling pointer on
	error. 
	(raptor_rdfxml_serialize_end) No-op if context->rdf_RDF_element is NULL.

	* src/raptor_uri.c: (raptor_uri_to_counted_string) Copy uri
	string, not uri struct - worked previously with raptor_uris but
	breaks with librdf_uris. No need to allocate +sizeof(char*).

	* src, tests, utils: Props: ignore .exes

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_ensure_writen_header)
	Forgot to return 0 on success - oops

2007-09-25  Dave Beckett <dave@dajobe.org>

	* autogen.sh: Use 3-part versions with perl to decode them.  Still
	broken for autoconf

2007-09-25  Lauri Aalto <laalto@iki.fi>

	* src/raptor_xml_writer.c: (raptor_iostream_write_xml_element_start)
	Check for alloc failures and clean up nspace_declarations on
	failure.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_ensure_writen_header)
	Check for alloc failures. Return an error code on failure.
	(raptor_rdfxml_serialize_statement) Check for
	raptor_rdfxml_ensure_writen_header() return code.
	(raptor_rdfxml_ensure_writen_header) Ignore
	raptor_rdfxml_ensure_writen_header() return code in a cleanup
	function.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_statement)
	Get a copy of predicate uri string for modification. Check for
	alloc failures and clean up on error. Refactored to use
	raptor_new_xml_element_from_namespace_local_name().

	* src/raptor.h, src/raptor_xml.c: Refactoring: Added
	raptor_new_xml_element_from_namespace_local_name(). Pulled from
	rasqal_query_results_new_xml_element() - the same xml element
	creation pattern recurs in other serializers as well.

2007-09-24  Lauri Aalto <laalto@iki.fi>

	* autogen.sh: Do not compare versions as decimal, e.g. automake
	1.10 should be treated newer than 1.7.
	(update_prog_version) Convert [z.]x.y version strings to 100x+y.

2007-09-23  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Revert GRDDL to the main algorithm of around
	12377 which passes the tests again and
	Fixes Issue#0000239 http://bugs.librdf.org/mantis/view.php?id=239

	(raptor_grddl_parser_add_parent): Restored.
	(raptor_grddl_copy_state): Removed
	(raptor_grddl_new_child_parser): Removed.
	(raptor_grddl_run_recursive): Remove reference to the above -
	replacing raptor_grddl_new_child_parser with
	raptor_grddl_ensure_internal_parser and replacing 'nparser'
	references with grddl_parser->internal_parser.

	* src/raptor_grddl.c: (raptor_grddl_discard_message): debug
	message tweak.

	* examples, tests, docs, docs/tmpl: props

	* docs/tmpl/section-uri-factory.sgml, docs/tmpl/section-uri.sgml,
	docs/tmpl/section-xml-namespace.sgml: Updated gtkdoc templates for
	raptor_uri_compare

2007-09-21  Lauri Aalto <laalto@iki.fi>

	* src/raptor.h, src/raptor_namespace.c:
	(raptor_new_namespace): Check for alloc failures and clean up on
	error.
	(raptor_namespaces_init): Changed to return an error code.

	* src/raptor_parse.c: (raptor_parse): Check for alloc
	failures. Clean up on failure.

	* src/raptor_rdfxml.c: (raptor_rdfxml_start_element_handler)
	return on fatal error, do not use NULL pointers.
	(raptor_rdfxml_end_element_grammar) abort() after reporting a
	fatal error.

	* src/raptor_serialize.c: (raptor_new_serializer): Check for alloc
	failures. Clean up on failure.

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_init):
	Check for alloc failures. Clean up on failure.

	* src/raptor_namespace.c: raptor_namespace.c: Fix comment typo

	* src/raptor_abbrev.c: (raptor_abbrev_subject_add_property) Free
	passed in nodes on error.

	* src/raptor_abbrev.c, src/raptor_sequence.c: raptor_sequence:
	Delete items to be inserted on error.
	Fixes Issue#0000237 http://bugs.librdf.org/mantis/view.php?id=237

	* src/fix-bison: bison parsers / fix-bison: Fix compiler warning
	about empty declarations (remove semicolon).

	* src/raptor_parse.c: (raptor_guess_parser_name) Fix compiler
	warnings about unnecessary const cast

	* src/raptor_rfc2396.c: (raptor_new_uri_detail) Check for alloc
	failure.

	* src/raptor_serialize_rdfxml.c: raptor_serialize_rdfxml: Fix
	compiler warnings about uninitialized variables.

	* src/raptor_serialize_rdfxmla.c: (raptor_rdfxmla_ensure_writen_header)
	Fix compiler warning about uninitialized variable.

	* src/raptor_xml_writer.c: (raptor_iostream_write_xml_element_start)
	Check for alloc failure

	* src/raptor_internal.h: raptor_internal.h: Allow
	RAPTOR_WWW_BUFFER_SIZE to be externally defined. Can save stack
	space in some resource-constrained environments with smaller
	buffers.

	* src/raptor_internal.h: raptor_internal.h: Allow
	RAPTOR_ASSERT_DIE to be externally defined e.g. in a makefile.

	* src/raptor_internal.h: raptor_internal.h: Rearrange include file
	guards to include stdlib.h without dmalloc.

	* src/raptor_general.c: (raptor_init) Set initialized flag early
	to allow cleanup with raptor_finish() on init errors.

	* src/raptor_general.c: (raptor_log_error) Do not abort() on fatal
	messages - leave it up to caller to enable resource cleanup.

	* src/raptor_general.c: (raptor_statement_part_as_counted_string)
	Fix compiler warnings about uninitialized variables.

	* src/raptor_rss_common.c, src/raptor_sax2.c: Fix compiler
	warnings about possible unwanted semicolons

	* src/raptor_serialize.c: Fix typos in comments

	* src/raptor_sax2.c: Fix indent

	* Makefile.am, autogen.sh, configure.ac, data/Makefile.am,
	docs/Makefile.am, examples/Makefile.am, src/Makefile.am,
	tests/22-rdf-syntax-ns.rdf, tests/Makefile.am,
	tests/all-escape.rdf, tests/bad-00.rdf, tests/bad-01.rdf,
	tests/bad-02.rdf, tests/bad-03.rdf, tests/bad-04.rdf,
	tests/bad-05.rdf, tests/bad-06.rdf, tests/bad-07.rdf,
	tests/bad-08.rdf, tests/bad-09.rdf, tests/bad-10.rdf,
	tests/bad-11.rdf, tests/bad-12.rdf, tests/bad-13.rdf,
	tests/bad-14.rdf, tests/bad-15.rdf, tests/bad-16.rdf,
	tests/bad-17.rdf, tests/bad-18.rdf, tests/bad-19.rdf,
	tests/bad-20.rdf, tests/bad-21.rdf, tests/bad-22.rdf,
	tests/bad-23.rdf, tests/daml-oil.rdf, tests/ex-00.rdf,
	tests/ex-01.rdf, tests/ex-02.rdf, tests/ex-03.rdf,
	tests/ex-04.rdf, tests/ex-05.rdf, tests/ex-06.rdf,
	tests/ex-07.rdf, tests/ex-08.rdf, tests/ex-09.rdf,
	tests/ex-10.rdf, tests/ex-11.rdf, tests/ex-12.rdf,
	tests/ex-13.rdf, tests/ex-14.rdf, tests/ex-15.rdf,
	tests/ex-16.rdf, tests/ex-17.rdf, tests/ex-18.rdf,
	tests/ex-19.rdf, tests/ex-20.rdf, tests/ex-21.rdf,
	tests/ex-22.rdf, tests/ex-23.rdf, tests/ex-24.rdf,
	tests/ex-25.rdf, tests/ex-26.rdf, tests/ex-27.rdf,
	tests/ex-28.rdf, tests/ex-29.rdf, tests/ex-30.rdf,
	tests/ex-31.rdf, tests/ex-32.rdf, tests/ex-33.rdf,
	tests/ex-34.rdf, tests/ex-35.rdf, tests/ex-36.rdf,
	tests/ex-37.rdf, tests/ex-38.rdf, tests/ex-39.rdf,
	tests/ex-40.rdf, tests/ex-41.rdf, tests/ex-42.rdf,
	tests/ex-43.rdf, tests/ex-44.rdf, tests/ex-45.rdf,
	tests/ex-46.rdf, tests/ex-47.rdf, tests/ex-48.rdf,
	tests/ex-49.rdf, tests/ex-51.rdf, tests/ex-53.rdf,
	tests/ex-54.rdf, tests/ex-55.rdf, tests/ex-56.rdf,
	tests/ex-57.rdf, tests/ex-58.rdf, tests/ex-59.rdf,
	tests/ex-60.rdf, tests/ex-61.rdf, tests/ex-62.rdf,
	tests/turtle/Makefile.am, tests/turtle/bad-00.ttl,
	tests/turtle/bad-01.ttl, tests/turtle/bad-02.ttl,
	tests/turtle/bad-03.ttl, tests/turtle/bad-04.ttl,
	tests/turtle/bad-05.ttl, tests/turtle/bad-06.ttl,
	tests/turtle/bad-07.ttl, tests/turtle/bad-08.ttl,
	tests/turtle/bad-09.ttl, tests/turtle/bad-10.ttl,
	tests/turtle/bad-11.ttl, tests/turtle/bad-12.ttl,
	tests/turtle/bad-13.ttl, tests/turtle/bad-14.ttl,
	tests/turtle/manifest-bad.ttl, tests/turtle/manifest.ttl,
	tests/turtle/rdf-schema.out, tests/turtle/rdf-schema.ttl,
	tests/turtle/rdfq-results.out, tests/turtle/rdfq-results.ttl,
	tests/turtle/rdfs-namespace.out, tests/turtle/rdfs-namespace.ttl,
	tests/turtle/test-00.out, tests/turtle/test-00.ttl,
	tests/turtle/test-01.out, tests/turtle/test-01.ttl,
	tests/turtle/test-02.out, tests/turtle/test-02.ttl,
	tests/turtle/test-03.out, tests/turtle/test-03.ttl,
	tests/turtle/test-04.out, tests/turtle/test-04.ttl,
	tests/turtle/test-05.out, tests/turtle/test-05.ttl,
	tests/turtle/test-06.out, tests/turtle/test-06.ttl,
	tests/turtle/test-07.out, tests/turtle/test-07.ttl,
	tests/turtle/test-08.out, tests/turtle/test-08.ttl,
	tests/turtle/test-09.out, tests/turtle/test-09.ttl,
	tests/turtle/test-10.out, tests/turtle/test-10.ttl,
	tests/turtle/test-11.out, tests/turtle/test-11.ttl,
	tests/turtle/test-12.out, tests/turtle/test-12.ttl,
	tests/turtle/test-13.out, tests/turtle/test-13.ttl,
	tests/turtle/test-14.out, tests/turtle/test-14.ttl,
	tests/turtle/test-15.out, tests/turtle/test-15.ttl,
	tests/turtle/test-16.out, tests/turtle/test-16.ttl,
	tests/turtle/test-17.out, tests/turtle/test-17.ttl,
	tests/turtle/test-18.out, tests/turtle/test-18.ttl,
	tests/turtle/test-19.out, tests/turtle/test-19.ttl,
	tests/turtle/test-20.out, tests/turtle/test-20.ttl,
	tests/turtle/test-21.out, tests/turtle/test-21.ttl,
	tests/turtle/test-22.out, tests/turtle/test-22.ttl,
	tests/turtle/test-23.out, tests/turtle/test-23.ttl,
	tests/turtle/test-24.out, tests/turtle/test-24.ttl,
	tests/turtle/test-25.out, tests/turtle/test-25.ttl,
	tests/turtle/test-26.out, tests/turtle/test-26.ttl,
	tests/turtle/test-27.out, tests/turtle/test-27.ttl,
	tests/turtle/test-28-out.ttl, tests/turtle/test-28.out,
	tests/turtle/test-28.ttl, tests/turtle/test-29.out,
	tests/turtle/test-29.ttl, tests/turtle/test-30.out,
	tests/turtle/test-30.ttl, utils/Makefile.am, win32/Makefile.am:
	Fix EOL issues when building svn version on cygwin.
	Partial fix to http://bugs.librdf.org/mantis/view.php?id=236

	* tests/Makefile.am, tests/turtle/Makefile.am: Added $(EXEEXT)s to
	Makefiles to fix "make clean" on cygwin. Partial fix to
	Issue#0000235 http://bugs.librdf.org/mantis/view.php?id=235

	* autogen.sh: raptor autogen.sh $dir quoting. Partial fix to
	Issue#0000234 http://bugs.librdf.org/mantis/view.php?id=234

2007-09-20  Dave Beckett <dave@dajobe.org>

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_recognise_syntax):
	Check for presence of html in the mime type correctly.

2007-09-19  Dave Beckett <dave@dajobe.org>

	* src/raptor_parse.c: (raptor_parse_uri_with_connection): Ensure a
	parser is started if it wasn't started during WWW retrieval -
	typically this is only if the file was empty (o bytes).  Some RDF
	syntaxes are legal as an empty file so can produce a valid empty
	graph, such as N-Triples and Turtle.

2007-09-17  Dave Beckett <dave@dajobe.org>

	* src/raptor_turtle_writer.c: Add xsd boolean, decimal, double,
	integer URIs to structure
	(raptor_turtle_writer_literal): Use raptor_uri_equal instead of
	strcmps.  In Redland, this means no strcmps.

	* src/raptor_serialize_turtle.c: (raptor_turtle_serialize_start):
	Remove call to raptor_turtle_writer_base since
	raptor_new_turtle_writer will do it if necessary.

	* src/raptor_turtle_writer.c: (raptor_new_turtle_writer): Call
	raptor_turtle_writer_base with initial base URI if there is one.
	(raptor_turtle_writer_base): Adedd. Back to possibly generating a
	relative base, allowing this to be called multiple times and
	setting the actual writer base URI, potentially to NULL.
	(main): Adjust expected result to expect an @base

	* tests/turtle/test-28-out.ttl: @base and relative prefix

	* src/raptor_internal.h, src/raptor_serialize_turtle.c,
	src/raptor_turtle_writer.c: (raptor_turtle_writer_base): Added to
	generate @base as an absolute URI.
	(raptor_turtle_serialize_start): Call it if there is an output
	base URI.

2007-09-16  Dave Beckett <dave@dajobe.org>

	* docs/raptor-sections.txt: Add raptor_uri compare_func funcs

	* tests/turtle/manifest.ttl: Added test-26 to test-30 to manifest.

	* src/raptor_uri.c: (main): Ensure called is inited

	* src/raptor_uri.c: (main): Add tests for raptor_uri_compare and
	interface versioning.

	* src/raptor_uri.c: (raptor_uri_set_handler): Adjust handler to
	not have to point to const data and to have V1 or V2 declared by
	setting the initialised field.  Truncate it to 1 or 2.
	(raptor_uri_compare): Use interface version to decide whether to
	invoke the uri_compare method.
	(struct raptor_uri_default_handler): Set URI Interface version to 2.

	* src/raptor.h: (struct raptor_uri_handler): Add URI Interface
	versions 1 and 2 - adding raptor_uri_compare_func.  Overload the
	'initialised' field to store the API version.  Existing Redland
	sets that to 1.
	(raptor_uri_set_handler): Adjust handler to not have to point to
	const data.

	* configure.ac, docs/libraptor.3, docs/raptor-parsers.xml,
	raptor.rdf.in, src/raptor_grddl.c, src/raptor_internal.h,
	src/raptor_parse.c: Remove RDFa support for now

2007-09-15  Dave Beckett <dave@dajobe.org>

	* docs/libraptor.3: 1.4.16

2007-09-15  Dave Robillard <dave@drobilla.net>

	* src/raptor.h, src/raptor_uri.c: (raptor_uri_handler): Move new
	raptor_uri_compare method to end of struct to limit ABI breakage.

2007-09-15  Dave Beckett <dave@dajobe.org>

	* src/raptor_internal.h, src/raptor_parse.c, src/raptor_rdfxml.c,
	src/raptor_set.c: Make raptor_set_test less chatty

	* tests/turtle/Makefile.am: Re-added test-30 now it's in SVN

	* tests/turtle/test-30.out, tests/turtle/test-30.ttl: test-30 for @base

2007-09-15  Dave Robillard <dave@drobilla.net>

	* docs/tmpl/section-uri.sgml, src/raptor.h, src/raptor_abbrev.c,
	src/raptor_uri.c: (raptor_uri_compare): Added for librdf
	overloading (rather than using strcmp directly).

	* tests/turtle/Makefile.am: Remove references to nonexistant test-30

	* src/raptor_abbrev.c, src/raptor_internal.h,
	src/raptor_serialize_rdfxmla.c, src/raptor_serialize_turtle.c: Use
	AVL tree rather than sequence for abbreviated serialisers (turtle
	& rdfxmla), significant performance improvement for large
	serialisations.
	(raptor_abbrev_node_lookup): Use AVL tree search against
	abbrev_node instead of linear sequence search.
	(raptor_abbrev_node_cmp): Adapt old raptor_abbrev_node_equals to
	provide strcmp-like ordering.
	(raptor_abbrev_node_equals): Change to trivial wrapper around new
	raptor_abbrev_node_cmp.

2007-09-14  Dave Robillard <dave@drobilla.net>

	* src/raptor_serialize_turtle.c: Fix unwanted blank line at end of
	Turtle list abbreviation.  e.g. before:
	:foo :bar (
	    1
	    2
		3

	) .

	after:

	:foo :bar (
	    1
	    2
	    3
	) .

2007-09-11  Dave Beckett <dave@dajobe.org>

	* src/turtle_lexer.l, src/turtle_parser.y: Added turtle @base

	* tests/turtle/Makefile.am: Adde test-30 for @base

2007-09-08  Dave Beckett <dave@dajobe.org>

	* src/raptor_sax2.c: (raptor_sax2_finish): Reset libxml error
	handlers to defaults.
	Fixes Issue#0000232 http://bugs.librdf.org/mantis/view.php?id=232

2007-09-06  Dave Beckett <dave@dajobe.org>

	* src/turtle_common.c: docs fix

2007-09-03  Dave Beckett <dave@dajobe.org>

	* src/turtle_lexer.l: {QUOTEDURI}: Apply turtle escapes to URIs

	* tests/turtle/test-29.out, tests/turtle/test-29.ttl: Fix line
	endings of test-29

	* tests/turtle/Makefile.am, tests/turtle/test-29.out,
	tests/turtle/test-29.ttl: test-29: Test all ntriples/turtle
	escapes U+0001 to U+007F

	* src/snprintf.c: Define __USE_ISOC99 to 1

	* src/raptor_rss.c: (raptor_rss_end_element_handler): Fixed a bug
	that silently discarded non-empty fields -- oops.

	* src/raptor_rss.c: raptor_rss_uplift_map: copy atom:updated to
	dc:date

	* configure.ac: Make sure to define HAVE_CURL_CURL_H when
	curl/curl.h is found

2007-09-01  Dave Beckett <dave@dajobe.org>

	* docs/libraptor.3: Added RDFa

2007-08-28  Dave Beckett <dave@dajobe.org>

	* docs/libraptor.3: Added description of new 1.4.16 functions

2007-08-27  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: GRDDL and RDFa

	* src/snprintf.c: just leave raptor_format_float for now.

	* docs/rdfcat.c, docs/rdfprint.c, docs/rdfserialize.c: Added C examples

2007-08-26  Dave Beckett <dave@dajobe.org>

	* docs/raptor-tutorial-parsing.xml: parsing filtering tutorial docs

	* docs/raptor-parsers.xml: GRDDL docs

	* src/raptor_grddl.c: (raptor_grddl_fetch_uri): Set WWW timeout
	from value of new parser feature RAPTOR_FEATURE_WWW_TIMEOUT

	* src/raptor.h, src/raptor_feature.c, src/raptor_parse.c,
	src/raptor_sax2.c, src/raptor_serialize.c,
	src/raptor_turtle_writer.c, src/raptor_xml_writer.c: Added parser
	feature RAPTOR_FEATURE_WWW_TIMEOUT

2007-08-25  Dave Beckett <dave@dajobe.org>

	* src/raptor_general.c, src/raptor_nfc.c,
	src/raptor_serialize_ntriples.c, src/raptor_xml.c: Use
	raptor_unichar instead of unsigned long for a Unicode codepoint

	* src/raptor_utf8.c: (raptor_unicode_char_to_utf8,
	raptor_utf8_to_unicode_char,
	raptor_unicode_is_xml11_namestartchar,
	raptor_unicode_is_xml10_namestartchar,
	raptor_unicode_is_xml11_namechar, raptor_unicode_is_xml10_namechar
	raptor_unicode_is_namestartchar, raptor_unicode_is_namechar):
	Updated to take a raptor_unichar argument.

	* src/raptor_internal.h: Update the raptor_unicode_* functions
	that take a unicode char to use raptor_unichar:
	raptor_unicode_is_namestartchar and raptor_unicode_is_namechar

	* src/raptor.h: Define raptor_unichar for a Unicode codepoint
	instead of unsigned long.  Update the raptor_unicode_* functions
	that take a unicode char to use it: raptor_unicode_char_to_utf8,
	raptor_utf8_to_unicode_char,
	raptor_unicode_is_xml11_namestartchar,
	raptor_unicode_is_xml10_namestartchar,
	raptor_unicode_is_xml11_namechar and
	raptor_unicode_is_xml10_namechar.

	* src/raptor_nfc.h: Remove unused u32

	* src/raptor.h: Document RAPTOR_FEATURE_HTML_LINK

	* src/snprintf.c: raptor_format_float not public

	* docs/libraptor.3: 1.4.16

2007-08-24  Dave Beckett <dave@dajobe.org>

	* utils/rapper.c: word

2007-08-24  Dave Robillard <dave@drobilla.net>

	* AUTHORS: Test commit (added undeserving self to AUTHORS).

2007-08-24  Dave Beckett <dave@dajobe.org>

	* tests/turtle/Makefile.am: (check-turtle-serialize-syntaxs):
	srcdir added for diff and cmp

2007-08-19  Dave Robillard <dave@drobilla.net>

	* AUTHORS: Added Dave Robillard

2007-08-19  Dave Beckett <dave@dajobe.org>

	* utils/rapper.c: words

	* utils/rapper.1: Added -I/--input-uri and -O/--output-uri

	* utils/rapper.c: Added -I/--input-uri and -O/--output-uri to set
	the input/parser base URI and output/serializer base URI directly
	Defaults remain the same - the serializer base URI defaults to the
	input base URI, however it was set.  Tidied the verbose messages
	to mention parser name.  Added a message for the serializer name
	too.

2007-08-18  Dave Beckett <dave@dajobe.org>

	* src/turtle_parser.y: (raptor_turtle_parser_register_factory):
	Make default application/x-turtle for now

	* src/raptor_parse.c: (raptor_parser_factory_add_mime_type): docs
	were wrong.

	* src/raptor_serialize_dot.c: (raptor_dot_serializer_end): Handle
	a missing base URI.
	Fixes Issue#0000216 http://bugs.librdf.org/mantis/view.php?id=216

2007-08-17  Dave Beckett <dave@dajobe.org>

	* src/raptor.h: Applied raptor part of symbian portability fix for
	Issue#0000203 http://bugs.librdf.org/mantis/view.php?id=203

2007-08-14  Dave Beckett <dave@dajobe.org>

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_recognise_syntax):
	Apply a negative score if html is in the mime type.  Do not
	recognize as rdf if <html is present or the html namespace is
	declared.

2007-08-05  Dave Beckett <dave@dajobe.org>

	* src/raptor_xml_writer.c: (main) Quieter unit test

	* src/snprintf.c: #ifdef out unused dopr_outch prototype

	* src/turtle_common.c: (raptor_stringbuffer_append_turtle_string):
	Take const string arg.

	* src/raptor_internal.h: Update prototypes for
	raptor_turtle_writer_quoted and raptor_turtle_writer_literal to
	take const string args.

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_quoted,
	raptor_turtle_writer_literal): const string args.
	(main): Unit tests

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_double):
	Renamed from snprint_turtle_double and now goes direct to the
	writer's iostream. Serialize NaN, -INF and INF numbers

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_literal): Use
	raptor_format_float to format decimals.

	* src/Makefile.am: Added snprintf.c

	* src/snprintf.c: (raptor_format_float): Renamed from fmtfp and
	edited to be XSD rules.

	* src/raptor_internal.h: Added raptor_format_float

	* src/raptor_parse.c: (raptor_parse_file_stream): C99

	* tests/turtle/test-28-out.ttl, tests/turtle/test-28.out,
	tests/turtle/test-28.ttl: Update test-28 results for truncating to
	precision

	* tests/turtle/Makefile.am: Remove test-28 from roundtrip exact
	test

	* tests/turtle/Makefile.am: minor fix

	* tests/turtle/Makefile.am: (check-turtle-serialize-syntax): diff
	always in text

	* tests/turtle/test-28-out.ttl: fix expected output

	* tests/turtle/Makefile.am: comment

	* tests/turtle/Makefile.am, tests/turtle/test-28-out.ttl,
	tests/turtle/test-28.out: Check test-28 for exact syntax returned
	as well as triples

2007-08-02  Dave Beckett <dave@dajobe.org>

	* src/raptor_parse.c: (raptor_parse_file_stream): Always NULL
	terminate the read buffer.

	* tests/turtle/Makefile.am, tests/turtle/test-28.out,
	tests/turtle/test-28.ttl: Added test-28.ttl test-28.out for
	serializing xsd:double

2007-07-29  Dave Beckett <dave@dajobe.org>

	* src/raptor_set.c: (main): Make test silent when successful.

	* src/raptor_avltree.c: remove debug

	* src/raptor_set.c: comment

	* src/raptor_avltree.c: print_string is not needed unless debugging

	* src/raptor_set.c: Switch to use raptor_avltree for ID sets

	* src/raptor_avltree.c, src/raptor_internal.h: Rename constructor
	and destructor

	* src/raptor_avltree.c: (main): Make test silent when successful.

	* src/raptor_avltree.c: Conditionalise detailed AVL-tree debugging

	* src/Makefile.am: Add raptor_avltree_test to TESTS

	* src/Makefile.am, src/raptor_avltree.c, src/raptor_internal.h:
	Added AVL-Tree code

2007-07-19  Dave Beckett <dave@dajobe.org>

	* src/raptor_serialize.c: docs

2007-07-13  Dave Beckett <dave@dajobe.org>

	* src/raptor_turtle_writer.c: (snprint_turtle_double): Tidy to
	remove several strlen()s

	* src/raptor_serialize_rss.c: cast

	* src/raptor_serialize_rss.c: (raptor_rss10_serialize_statement):
	Do not debug die when rdf:Seq node is a blank node.

2007-07-08  Dave Beckett <dave@dajobe.org>

	* src/raptor_serialize_rdfxml.c: (raptor_rdfxml_serialize_start):
	Pass on the xml declaration feature to the xml writer.
	Fixes Issue #0000210 http://bugs.librdf.org/mantis/view.php?id=210

	* src/raptor_grddl.c: struct raptor_grddl_parser_context_s gains
	html_link_processing to enable looking for <html> <link> with
	RDF/XML value.
	(raptor_grddl_parse_init_common): Enable html <link> by default.
	(raptor_rdfa_parse_init): Disable html <link> for RDFA parser.
	(raptor_grddl_parse_chunk): Check for html <link> available as
	well as allowed by feature.

2007-07-05  Dave Beckett <dave@dajobe.org>

	* docs/tmpl/section-feature.sgml, src/raptor.h,
	src/raptor_feature.c, src/raptor_grddl.c, src/raptor_parse.c,
	src/raptor_sax2.c, src/raptor_serialize.c,
	src/raptor_turtle_writer.c, src/raptor_xml_writer.c: Added
	RAPTOR_FEATURE_HTML_LINK to control GRDDL looking for html <link
	type="application/rdf+xml" href="uri">

2007-07-04  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (grddl_free_xml_context): Free the context
	itself.
	(raptor_grddl_parser_add_parent): Deleted, merged into
	raptor_grddl_new_child_parser.  Delete html:link entry from table
	for now - handle rdf/xml links specially later.
	(raptor_grddl_copy_state): Added, pulled out of
	raptor_grddl_ensure_internal_parser
	(raptor_grddl_ensure_internal_parser): Call
	raptor_grddl_copy_state
	(raptor_grddl_new_child_parser): Added, from
	raptor_grddl_ensure_internal_parser and
	raptor_grddl_parser_add_parent to allocate a new parser rather
	than overwrite the 'internal_parser'.
	(raptor_grddl_fetch_uri): Set/reset the content type handler
	eachtime.
	(raptor_grddl_run_xpath_match): Free URI after calculating
	relative to base.
	(raptor_grddl_run_recursive): Gains filter arg, again.  Use
	raptor_grddl_new_child_parser to make a new (GRDDL) raptor_parser*
	and free it here when done.
	(raptor_grddl_parse_chunk): Add new filter arg to
	raptor_grddl_run_recursive Look for <link
	type="application/rdf+xml" href="URI" /> with RDF expected, not an
	XSLT transform URI.

	* src/raptor_www_curl.c: (raptor_www_curl_header_callback): Handle
	multiple type headers appearing, overwriting - such as during an
	HTTP redirect.

2007-07-03  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_discard_message): Report
	discarded errors when debugging.
	(raptor_grddl_parse_chunk): Run XML then HTML parsing in sequence,
	discarding all errors here.  Restore the error handlers
	afterwards. Move tidying up of buffers to function exit tidying.

	* src/raptor_libxml.c: (raptor_libxml_xmlStructuredErrorFunc):
	Tidy output to say "HTML Parser" not "XML HTML Parser"

2007-07-02  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: style

	* src/raptor_grddl.c: match-table gains: looking for
	<link type="application/rdf+xml" href="URI" />

	* utils/rapper.c: Remove const for print_graph

	* src/raptor_serialize_turtle.c: raptor_turtle_context gains
	rdf_nil_uri. Tidy some error messages to remove ()s
	(raptor_turtle_emit_subject_collection_items): At the object of an
	rdf:rest, if it's blank, check it exists and make it the new
	subject, otherwise check it's a URI called rdf:nil.
	(raptor_turtle_serialize_init, raptor_turtle_serialize_terminate):
	Init/free rdf:rest URI.
	Fixes Issue#0000207 http://bugs.librdf.org/mantis/view.php?id=207

	* tests/Makefile.am, tests/ex-62.rdf: Added ex-62 for Issue#0000207

2007-06-23  Dave Beckett <dave@dajobe.org>

	* src/snprintf.c: style, ANSI C and std headers

	* src/snprintf.c: Import Public Domain snprintf from mutt:
	http://dev.mutt.org/hg/mutt/file/55cd4cb611d9/snprintf.c Last
	Modified: Tue Aug 08 22:49:12 2006 +0000.

2007-06-20  Dave Beckett <dave@dajobe.org>

	* raptor.rdf.in: Set Project URI
	Update syntaxes

	* src/raptor_grddl.c: Add XSLT security
	(raptor_init_parser_grddl_common): Deny reading, writing to files,
	creating directories or writing to network.
	(raptor_terminate_parser_grddl_common): Tidy up xslt security prefs.

2007-06-19  Dave Beckett <dave@dajobe.org>

	* src/raptor.h: raptor_graph_handler without const uri

	* tests/Makefile.am: Add trig dir

	* docs/raptor-parsers.xml: Update GRDDL
	Add RDFa and TRiG

	* utils/rapper.1: Added --show-graphs

	* utils/rapper.c: Added --show-graphs option to print named graph
	URIs as seen

	* tests/trig, tests/trig/Makefile.am, tests/trig/example1.out,
	tests/trig/example1.trig, tests/trig/example2.out,
	tests/trig/example2.trig, tests/trig/example3.out,
	tests/trig/example3.trig: Added TRiG tests

	* configure.ac: Add trig parser support, enabled by default.

	* src/Makefile.am: Added RAPTOR_PARSER_TRIG sharing turtle parser code

	* src/raptor.h: Added raptor_graph_handler
	Added raptor_set_graph_handler

	* src/raptor_parse.c: (raptor_parsers_init): Call
	raptor_init_parser_trig.
	(raptor_set_graph_handler): Added to get graph name callbacks.
	(raptor_parser_set_graph_name): Added internal function.

	* src/turtle_common.h: struct raptor_turtle_parser_s gains trig flag.

	* src/raptor_internal.h: struct raptor_parser_s gains field
	graph_handler Added raptor_init_parser_trig and
	raptor_parser_set_graph_name prototypes.


	* src/turtle_parser.y: Add TRiG support.  New tokens LEFT_CURLY,
	RIGHT_CURL, COLONMINUS ({, } and :-) New token graphName
	(colonMinusOpt): Added for TRiG's optional :-
	(graph): Added for TRiG graph name before { ... graph ... }
	(graphName): Added for TRiG
	(graphBody): Added for TRiG
	(triplesList): Added for TRiG
	(terminatedTriples): Added.
	(statement): uses graph, terminatedTriples
	(triples): Added, pulled out of statement
	(raptor_trig_parse_recognise_syntax): Recognise trig in url.
	(raptor_trig_parser_register_factory): Added for TRiG
	(raptor_init_parser_trig): Added for TRiG

	* src/turtle_lexer.l: Add { } and :- for TRiG

2007-06-12  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_run_grddl_transform_uri): Hack
	locator URI so errors with XSLT are reported against that URI not
	the documents.

	* src/raptor_grddl.c: (raptor_grddl_fetch_uri): Fix accept header

	* src/raptor_grddl.c: Use /* for root element

	* src/raptor_grddl.c: XML @dataview:transformation are only on the
	root element.

	* src/raptor_grddl.c: (raptor_grddl_check_recursive_content_type_handler):
	Renamed from raptor_grddl_check_rdf_content_type_handler since it
	stores all content types now. Check for HTML content type and set
	html_base processing flag 
	(raptor_grddl_run_recursive): Remove allow_rdf flag, always true.


	* src/raptor_grddl.c: struct raptor_grddl_parser_context_s gains
	xinclude_processing and html_base_processing flags.
	(raptor_grddl_parse_init_common): Initialise grddl, xinclude but
	not html base.
	(raptor_rdfa_parse_init): Disable grddl, xinclude and init html
	base.
	(raptor_grddl_run_xpath_match): If html_base_processing is
	enabled, switch XML doc type to XML_HTML for the xmlNodeGetBase()
	call and restore afterwards.
	(raptor_grddl_parse_chunk): Look for HTML or XHTML mime types to
	enable html_base_processing.  Conditionalise XML Include
	processing with xinclude_processing flag.

2007-06-10  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Debug message madness!
	(raptor_grddl_parse_chunk): After xinclude processing, reserialize
	the document DOM so it can be parsed later as RDF/XML if needed.

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Recognise root
	rdf:RDF element and process as RDF/XML.  Fix RDF/XML parsing of
	doc to not filter triples.

	* utils/rapper.c: If no base URI is given, do not set it

	* src/raptor_grddl.c: (raptor_grddl_run_recursive): Send to right
	parser.

	* tests/ex-61.nt, tests/ex-61.out (from
	/raptor/trunk/tests/ex-61.nt:12321): Rename ex-61.nt to ex-61.out

	* src/raptor_grddl.c: (raptor_grddl_parse_uri_write_bytes):
	Removed.
	(raptor_grddl_run_recursive): Use typedef
	raptor_parse_bytes_context with raptor_parse_uri_write_bytes as a
	handler for starting parse lazily

	* src/raptor_parse.c: Moved raptor_parse_bytes_context to
	raptor_internal.h
	(raptor_parse_uri_write_bytes): No longer static.

	* src/raptor_internal.h: Added raptor_parse_bytes_context Export
	raptor_parse_uri_write_bytes handler for use with GRDDL fetch.

	* src/raptor_parse.c: Added raptor_parse_bytes_context typedef
	(raptor_parse_uri_write_bytes): Use the above to look if this is the
	first time called, and if so, determine the base URI from the user's
	set base URI, the final URI from protocol, or otherwise, the resolved
	URI.  This prevents calling raptor_start_parse() until the first byte
	is seen (and thus the base URI, protocol context is known)
	(raptor_parse_uri_with_connection): Explains the base URI rules in
	detail.  Remove call to raptor_start_parse() and initialse the rpbc
	block.

	* src/raptor_www_curl.c: (raptor_www_curl_update_status): set
	final_uri and call final_uri_handler if set

	* src/raptor_www.c: (raptor_www_set_final_uri_handler): Added.

	* src/raptor.h: Added raptor_www_final_uri_handler typedef.  Added
	raptor_www_set_final_uri_handler prototype.

	* src/raptor_internal.h: raptor_www gains final_uri_userdata and
	final_uri_handler;

	* src/raptor_internal.h: struct raptor_www_s gains a
	checked_status flag

	* src/raptor_www_curl.c: (raptor_www_curl_update_status): Added.
	(raptor_www_curl_write_callback): Call raptor_www_curl_update_status
	from here when first byte arrives, before any parsing.
	(raptor_www_curl_fetch): Move getting final URI earlier - above.

	* src/raptor_www_curl.c: typo

	* tests/Makefile.am, tests/ex-61.nt, tests/ex-61.rdf: Added ex-61

	* src/raptor_www_curl.c: (raptor_www_curl_fetch): Save final URI

	* src/raptor_www.c: (raptor_www_get_final_uri): Added.

	* src/raptor.h: Added raptor_www_get_final_uri prototype

	* src/raptor_internal.h: struct raptor_www_s gains a final_uri field

	* src/raptor_sax2.c: (raptor_sax2_inscope_xml_language): Turn
	xml:lang="" into a NULL result.

	* src/raptor_grddl.c: (raptor_grddl_run_recursive): Zaps error
	handlers on recursive parse when ignore_errors set.

	* src/raptor_grddl.c: (raptor_grddl_fetch_uri): flags
	argument (was ignore_errors) can now send a different accept
	header.
	(raptor_grddl_run_grddl_transform_uri): Call
	raptor_grddl_fetch_uri and expect XSLT.
	(raptor_grddl_run_recursive): Call raptor_grddl_fetch_uri and
	ignore errors.

	* src/raptor_grddl.c: (raptor_grddl_discard_message): Added.
	(raptor_grddl_fetch_uri): Added ignore_errors argument to set the
	raptor_www error handler to raptor_grddl_discard_message
	(raptor_grddl_run_grddl_transform_uri): Do not discard errors from
	raptor_grddl_fetch_uri call.
	(raptor_grddl_run_recursive): Added ignore_errors argument and use
	it to return 0 with no warnings, when errors happen.
	(raptor_grddl_parse_chunk): Run namespace URI recursive grddl
	while discarding errors.  Run head profile URIs recursive grddl
	while discarding errors.

	* src/raptor_grddl.c: (raptor_grddl_run_grddl_transform_doc): Pass
	in an xml context and use the base URI there rather than the
	parser's.
	(raptor_grddl_run_grddl_transform_uri): Pass on the xml context to
	the above.

2007-06-09  Dave Beckett <dave@dajobe.org>

	* docs/tmpl/section-www.sgml: Added
	raptor_www_set_connection_timeout

	* docs/tmpl/section-feature.sgml: new feature
	@RAPTOR_FEATURE_MICROFORMATS

	* docs/raptor-sections.txt: Added
	raptor_www_set_connection_timeout

	* src/raptor_www_curl.c: (raptor_www_curl_init): Use
	www->connection_timeout.

	* src/raptor_www.c: (raptor_www_new_with_connection): Init
	connection timeout to 10s
	(raptor_www_set_connection_timeout): Added.

	* src/raptor.h: Add raptor_www_set_connection_timeout

	* src/raptor_internal.h: raptor_www gains connection_timeout

	* src/raptor_www_curl.c: (raptor_www_curl_init): Set a 10 second
	connection timeout.

	* src/raptor_libxml.c: (raptor_libxml_xmlStructuredErrorFunc): For
	HTTP error only, append str1 to the error.

	* src/raptor_grddl.c: Use XML base URI passed around with the
	grddl_xml_context.
	(raptor_new_xml_context): Renamed from
	raptor_sequence_push_xml_context, moving sequence push to main
	code.
	(raptor_rdfa_parse_init): Push URI for RDFa in
	raptor_grddl_parse_start.
	(raptor_grddl_parse_start): Add XML context for RDFa here.
	(raptor_grddl_add_transform_xml_context): Renamed from
	raptor_grddl_add_transform_uri
	(raptor_grddl_run_grddl_transform_doc): If there is no parser name
	guessable, return.
	(raptor_grddl_run_grddl_transform_uri): Take a grddl_xml_context*
	arg instead of raptor_uri.

2007-06-06  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Added grddl_xml_context structure.
	Transform and profile URI raptor_sequences are now sequences of
	grddl_xml_context structures.
	(raptor_sequence_push_xml_context, grddl_free_xml_context): Added.
	(raptor_grddl_parse_init_common): No need for
	raptor_libxml_init_generic_error_handlers, raptor_new_sax2 does
	it.  Initialise raptor_sequence with grddl_free_xml_context.
	(raptor_grddl_add_transform_uri): Use
	raptor_sequence_push_xml_context.
	(raptor_grddl_filter_triples): Use grddl_xml_context for
	profile_uri sequence.
	(raptor_grddl_run_xpath_match): Use grddl_xml_context for URI
	results.
	(raptor_grddl_parse_chunk): Use raptor_sequence_push_xml_context
	for former URI sequences.

	* src/raptor_libxml.c: (raptor_libxml_generic_error): Now
	external, not static.  Call raptor_log_error_varargs direct, no
	mention of sax2, locator is from error_handlers.
	(raptor_libxml_init_generic_error_handlers): Removed.
	(raptor_libxml_xmlStructuredErrorFunc): Add err->str1 to message
	if it's given.

	* src/raptor_www_libxml.c: (raptor_www_libxml_http_error):
	Deleted, no longer needed.
	(raptor_www_libxml_init): Set xml generic error context, but save
	old one.
	(raptor_www_libxml_free): Restore old xml generic error context.

	* src/raptor_www.c: (raptor_www_new_with_connection): Init
	RAPTOR_ERROR_HANDLER_MAGIC
	(raptor_www_set_error_handler): Use error_handlers
	(raptor_www_error_varargs): Removed, merged into raptor_www_error
	(raptor_www_error): Call raptor_log_error_varargs here.

	* src/raptor_sax2.c: (raptor_new_sax2): Set xmlSetGenericErrorFunc
	here with the same context pointer as for structured errors.

	* src/raptor_parse.c: (raptor_new_parser): Init
	RAPTOR_ERROR_HANDLER_MAGIC

	* src/raptor_internal.h: removed
	raptor_libxml_init_generic_error_handlers prototype added
	raptor_libxml_generic_error prototype raptor_www gains
	old_xmlGenericErrorContext for libxml and error_handlers replacing
	older error_data, error_handle.  removed raptor_www_error_varargs
	prototype

	* src/raptor_sax2.c: SAX2 error_handler fix for expat

	* tests/turtle/Makefile.am, tests/turtle/test-27.out,
	tests/turtle/test-27.ttl: Added turtle test test-27 for scope of
	@prefix

2007-06-04  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Do an additional RDF/XML parse of content
	that is found to be RDF/XML by mime type during recursive GRDDL,
	and an additional parse of the top level content too, if also
	found.

	* src/raptor_parse.c: (raptor_parser_copy_user_state): Copy last
	feature too!

	* src/raptor_parse.c, src/raptor_sax2.c, src/raptor_serialize.c,
	src/raptor_turtle_writer.c, src/raptor_xml_writer.c: Added
	RAPTOR_FEATURE_MICROFORMATS

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Use feature
	RAPTOR_FEATURE_MICROFORMATS to dis/enable checking for hardcoded
	microformats

	* src/raptor_feature.c: C

	* src/raptor_feature.c: raptor_features_list gains
	RAPTOR_FEATURE_MICROFORMATS with name 'microformats'

	* src/raptor.h: Added RAPTOR_FEATURE_MICROFORMATS

	* src/raptor_grddl.c: Remove C++ comment

	* src/raptor_grddl.c: Added MATCH_LAST to stop searching for
	hardcoded sheets.  Add hReview sheet that if matches, stops
	looking for later microformats such as hCard.
	(raptor_grddl_parse_chunk): Use MATCH_LAST to stop looking for
	later hardcoded matches.
	(raptor_init_parser_grddl_common,
	raptor_terminate_parser_grddl_common): Added, called once for
	grddl or rdfa available.

	* src/raptor_parse.c: (raptor_parsers_init): Call
	raptor_init_parser_grddl_common for GRDDL or RDFA parsers.
	(raptor_parsers_finish): Call raptor_terminate_parser_grddl_common
	for GRDDL or RDFA parsers.

	* src/raptor_internal.h: Add prototypes for
	raptor_init_parser_grddl_common and
	raptor_terminate_parser_grddl_common

	* src/raptor_grddl.c: (raptor_grddl_add_transform_uri): Added, to
	add a transformation URI
	(XSLT) for a document, removing duplicate URIs.
	(raptor_grddl_filter_triples, raptor_grddl_parse_chunk): Use
	raptor_grddl_add_transform_uri.

2007-06-03  Dave Beckett <dave@dajobe.org>

	* configure.ac, src/raptor_grddl.c, src/raptor_internal.h,
	src/raptor_parse.c: Add RDFa parser

2007-05-27  Dave Beckett <dave@dajobe.org>

	* src/raptor_serialize.c: (raptor_serializer_register_factory):
	Fix debug call with RAPTOR_DEBUG>1
	Fixes Issue#0000195 http://bugs.librdf.org/mantis/view.php?id=195

2007-05-26  Dave Beckett <dave@dajobe.org>

	* src/raptor_uri.c: (raptor_uri_filename_to_uri_string): Make
	path_max bigger *2, not smaller /4.
	Fixes Issue#0000192 http://bugs.librdf.org/mantis/view.php?id=192

	* src/n3_parser.y: (n3_parser_error): Invoke
	raptor_parser_simple_error with a format string and arg.

	* src/turtle_parser.y: (turtle_parser_error): Invoke
	raptor_parser_simple_error with a format string and arg.

	* src/raptor.h: Allow _declspec and __declspec
	Fixes Issue#0000188 http://bugs.librdf.org/mantis/view.php?id=188

2007-05-23  Dave Beckett <dave@dajobe.org>

	* docs/tmpl/section-feature.sgml: Add RAPTOR_FEATURE_HTML_TAG_SOUP

2007-05-21  Dave Beckett <dave@dajobe.org>

	* configure.ac: Check for libxml/nanohttp.h only once the
	xml-config include paths have been setup.

	* configure.ac: Add -Wformat-security

2007-05-14  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Use
	HTML_PARSE_RECOVER if available

	* src/raptor.h, src/raptor_feature.c, src/raptor_grddl.c,
	src/raptor_parse.c, src/raptor_sax2.c, src/raptor_serialize.c,
	src/raptor_turtle_writer.c, src/raptor_xml_writer.c: Added parser
	feature RAPTOR_FEATURE_HTML_TAG_SOUP aka htmlTagSoup for use by
	GRDDL parser

	* src/raptor_libxml.c: debug bogus pointers not fail temporarily

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_recognise_syntax):
	Move buffer editing to raptor_guess_parser_name.

	* src/raptor_parse.c: (raptor_guess_parser_name): Only run
	recognise_syntax with first N bytes of content

	* src/raptor_grddl.c: debugmsg

	* src/raptor_grddl.c: Use HTML parser when XML parser fails, to
	create a DOM for GRDDLing from invalid/not-WF HTML content.
	raptor_grddl_parser_context_s gains htmlParserCtxt as well as
	xmlParserCtxt and process_this_as_rdfxml GRDDL flag to know when
	to parse the content twice.
	(raptor_grddl_parse_terminate): Tidy htmlParserCtxt.  Add
	MATCH_IS_HARDCODED to match_table just to make it clear.
	(match_table): Re-enable hcalendar and hcard as hardcoded XSLTs
	(raptor_grddl_run_xpath_match): Handle non-namespace elements.
	Handle MATCH_IS_HARDCODED and return on first match.
	(raptor_grddl_parse_chunk): Major change in structure - all
	content passed in is saved until is_end=1, then parsed with XML
	parser and if that fails, HTML parser.  HTML parser is run with no
	errors or warnings.

2007-05-11  Dave Beckett <dave@dajobe.org>

	* src/turtle_parser.y: (raptor_turtle_parse_recognise_syntax):
	Look for turtle @prefix and rdf namespace use in buffer.

	* src/n3_lexer.l: Add rule to allow a comment on the last line,
	without a final newline

	* src/turtle_lexer.l: Add rule to allow a comment on the last
	line, without a final newline

	* tests/turtle/Makefile.am, tests/turtle/test-26.out,
	tests/turtle/test-26.ttl: Add test-26

2007-05-10  Dave Beckett <dave@dajobe.org>

	* src/raptor_rdfxml.c: 's

2007-05-09  Dave Beckett <dave@dajobe.org>

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_recognise_syntax):
	Recognize rdf entities as namespaces.  Add bonus points for using
	the words rdf and rdf

2007-05-08  Dave Beckett <dave@dajobe.org>

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_recognise_syntax):
	Only use first 512 bytes of content for hunting for namespaces.

2007-04-26  Dave Beckett <dave@dajobe.org>

	* src/raptor_internal.h: struct raptor_www_s loses useless
	old_handler field for www_libxml

	* src/raptor_www_libxml.c: (raptor_www_libxml_init,
	raptor_www_libxml_free): Set, reset generic error func.

	* src/raptor_internal.h: Fix raptor_parse_date prototype

	* src/raptor_libxml.c: (raptor_libxml_init_generic_error_handlers):
	Use xmlSetGenericErrorFunc

	* src/parsedate.y: ANSI C function prototypes.

	* src/parsedate.y: Prototype for raptor_parse_date

2007-04-24  Dave Beckett <dave@dajobe.org>

	* src/raptor_general.c: raptor_log_level_labels make it the right size

	* src/raptor_grddl.c, src/raptor_parse.c, src/raptor_sax2.c:
	Update for error_handlers arrays.

	* src/raptor_libxml.c: (raptor_libxml_warning): Update for
	error_handlers arrays.  Also do not send an error to the warning
	handlers.
	(raptor_libxml_error_common, raptor_libxml_validation_warning):
	Update for error_handlers arrays.
	(raptor_libxml_xmlStructuredErrorFunc): Add xpath to the error
	message when the domain is XML_FROM_XPATH.  Ignore error_handlers
	if the pointer is bogus.  Use the arrays.  If error_handler is
	NULL, ignore it.

	* src/raptor_general.c: (raptor_error_handlers_init): Init error
	handler array fields and magic field.

	* src/raptor_internal.h: raptor_error_handlers now contains arrays
	of user_data and handlers and a magic field to check that an
	error_handler pointer is valid.

2007-04-22  Dave Beckett <dave@dajobe.org>

	* autogen.sh: Update autogen.sh

2007-04-14  Dave Beckett <dave@dajobe.org>

	* src/raptor_serialize_turtle.c: (raptor_turtle_emit_literal,
	raptor_turtle_emit_xml_literal): Send namespace stack to
	raptor_turtle_writer_literal

	* src/raptor_turtle_writer.c: (raptor_turtle_writer_literal): Add
	nspace field and use it to look up if a qname can be used for a
	datatype URI.

	* src/raptor_internal.h: raptor_turtle_writer_literal gains nspace
	field

	* src/raptor_parse.c: (raptor_guess_parser_name): Make suffix
	decoding work again

2007-04-10  Dave Beckett <dave@dajobe.org>

	* src/raptor_rss.c: (raptor_rss_parse_recognise_syntax): One more
	addition in the neverending guesswork that is rss tag soup.  This
	time for sites that have feed in the DNS name, or just somewhere
	in the URL.

	* src/raptor_parse.c: (raptor_guess_parser_name): Discard suffixes
	that are not '\.[a-zA-Z0-9]+$'

2007-03-27  Dave Beckett <dave@dajobe.org>

	* configure.ac: Check for curl header after inserting any cflags
	from curl-config.  This lets the curl test work when curl the
	includes are not in the usual places

2007-03-26  Dave Beckett <dave@dajobe.org>

	* configure.ac, src/win32_raptor_config.h: Bumped version to
	1.4.16

	* Snapshotted raptor_1_4_15 for 1.4.15 release (SVN r12027)

	* src/raptor_grddl.c: (raptor_grddl_parser_register_factory):
	Register XHTML mime type higher, very unlikely another parser is
	dealing with this.

	* src/raptor_rss.c: (raptor_rss_parse_recognise_syntax): Make mime
	type heuristics ignore anything with html in it so XHTML mime type
	is ignored.

2007-03-25  Dave Beckett <dave@dajobe.org>

	* src/raptor_internal.h: raptor_uri_detail_s gains is_hierarchical
	flag.
	
	* src/raptor_rfc2396.c: (raptor_new_uri_detail): Set
	is_hierarchical flag.
	(raptor_uri_resolve_uri_reference): Handle a non-hierarchical base
	URI.
	Fixes Issue#0000177 http://bugs.librdf.org/mantis/view.php?id=177
	(main): Fix above changes an earlier test:
	From:
	  resolve("foo:", "not_scheme:blah") => "foo:/not_scheme:blah"
	To:
	  resolve("foo:", "not_scheme:blah") => "foo:not_scheme:blah"

	* src/raptor_rfc2396.c: (main): Add test to confirm report from
	Issue#000177 http://bugs.librdf.org/mantis/view.php?id=177

	* utils/rapper.c: Print all informational and help messages to
	stderr.  Only results of parsing and the help (-h/--help) message
	goes to stdout now.

2007-03-22  Dave Beckett <dave@dajobe.org>

	* src/raptor_xml_writer.c, src/ntriples_parse.c,
	src/raptor_grddl.c, src/raptor_parse.c: Casts for C++

	* examples/grapper.c: Use library variables for license, home page

	* examples/grapper.c: Casts and C99 fixes

	* src/raptor_rss.h: Fix CONTENT_NAMESPACE_URI to correct URI

2007-03-19  Dave Beckett <dave@dajobe.org>

	* utils/rapper.c: NULL base URI

	* tests/Makefile.am: Set rapper output baseuri to NULL via '-'

	* utils/rapper.1, utils/rapper.c: Allow base uri '-' for no output
	base URI

	* src/raptor_www.c: (raptor_www_fetch): If a request returns a
	status code that is not success, generate an error message.

	* src/raptor_www_curl.c: (raptor_www_curl_fetch): Enhance failure
	error message

2007-03-15  Dave Beckett <dave@dajobe.org>

	* src/raptor_serialize_rss.c: Adjust the xml:base attribute adding
	to put it next to the raptor_xml_writer_start_element of the root
	element.

	* src/raptor_serialize_rdfxmla.c:
	raptor_rdfxmla_serializer_context gains xml_nspace field.
	(raptor_rdfxmla_serialize_init,
	raptor_rdfxmla_serialize_terminate): Init/free xml namespace.
	(raptor_rdfxmla_ensure_writen_header): Write xml:base when a base
	URI is given.
	Addresses Issue #0000174 http://bugs.librdf.org/mantis/view.php?id=174

	* src/raptor_serialize_rdfxml.c: raptor_rdfxml_serializer_context
	gains xml_nspace field.
	(raptor_rdfxml_serialize_init, raptor_rdfxml_serialize_terminate):
	Init/free xml namespace.
	(raptor_rdfxml_ensure_writen_header): Write xml:base when a base
	URI is given.
	Addresses Issue #0000174 http://bugs.librdf.org/mantis/view.php?id=174

2007-03-12  Dave Beckett <dave@dajobe.org>

	* src/raptor_rss.c, src/raptor_serialize_rss.c: Replace shared
	nspaces list with one per rss-parser/serializer.

	* src/raptor_rss.h: raptor_rss_namespace_info looses nspace field.

	* src/raptor_rfc2396.c: (raptor_uri_resolve_uri_reference): In
	removing ./ do not go past end of buffer.

2007-03-11  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: struct raptor_grddl_parser_context_s gains
	content_type, content_type_check and stringbuffer for saved
	rdf/xml content.
	(raptor_grddl_parse_terminate): Free any saved content type or
	stringbuffer.
	(raptor_grddl_parse_start): Init type check.
	(raptor_grddl_libxml_discard_error): Restore, for discarding
	validation errors again.
	(raptor_grddl_parse_chunk): If content type was seen and type was
	application/rdf+xml, save content for later parsing as RDF/XML.
	Discard validation errors again.
	(raptor_grddl_parse_content_type_handler): Save content type
	header when passed in.
	(raptor_grddl_parser_register_factory): Register
	raptor_grddl_parse_content_type_handler.

	* src/raptor_parse.c: (raptor_guess_parser_name): Add any mime
	type q <10 to the score, don't lose it entirely.

2007-03-02  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Alter match_table to look for substrings
	inside html:link@rel and html:a@rel Delete old hard-coded
	transforms for dc: never worked and embedded RDF: grddl profile
	support handles this now.

	* src/raptor_grddl.c: (raptor_grddl_run_grddl_transform_doc):
	Invoke xsltSetGenericErrorFunc here to get the right rdf_parser
	configured.

	* src/raptor_grddl.c: Handles GRDDL W3C Working Draft 2 March 2007

	* src/raptor_grddl.c: (raptor_grddl_libxml_discard_error): Deleted.
	(raptor_grddl_parse_chunk): No longer ignore validation errors
	http://lists.w3.org/Archives/Public/public-grddl-comments/2007JanMar/0062.html

2007-02-15  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_run_grddl_transform_uri):
	Return a warning and do not fail if XSLT sheet is not found
	(raptor_grddl_run_recursive): Return a warning and do not fail if
	the recursive GRDDL doc is not found.
	(raptor_grddl_parse_chunk): Tidy other errors.  Add aborting on
	XInclude failure.

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Do not get/set
	content when there was no internal parser.

	* src/raptor_grddl.c: (raptor_grddl_ensure_internal_parser): Unset
	user_data/statement_handler if filter is not used so that re-using
	the same parser with different filter now works.
	(raptor_grddl_fetch_uri): Add content_type_handler and
	content_type_user_data args and use them to call
	raptor_www_set_content_type_handler if not NULL.
	(raptor_grddl_run_grddl_transform_uri): Update
	raptor_grddl_fetch_uri call
	(raptor_grddl_check_rdf_content_type_handler): Handler to look for
	RDF MIME Type and trigger content saving if so.
	(raptor_grddl_run_recursive): Add allow_rdf argument to allow
	RDF/XML content to be processed if the type is right.
	(raptor_grddl_parse_chunk): For a namespace URI, run recursive and
	allow RDF/XML.  If it was seen on return, create a new "rdfxml"
	parser and run it.  Reorder setting the root_ns_uri profile
	earlier so that it can be recognised as a transform in RDF/XML
	namespace documents.

	* src/raptor_parse.c: (raptor_parse_chunk): If the stringbuffer is
	declared, save a copy of the bytes that pass by.
	(raptor_parser_save_content, raptor_parser_get_content): Added to
	trigger/reset saving content and to get the content back as a new
	string.

	* src/raptor_internal.h: raptor_parser gains a stringbuffer Added
	prototypes for raptor_parser_save_content and
	raptor_parser_get_content

2007-02-12  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_parse_init): Update
	raptor_new_sax2 call. Delete raptor_sax2_set_locator.

	* src/raptor_rss.c: (raptor_rss_parse_init): Update
	raptor_new_sax2 call. Delete raptor_sax2_set_locator.

	* src/raptor_rdfxml.c: (raptor_rdfxml_parse_init): Update
	raptor_new_sax2 call. Delete raptor_sax2_set_locator.

	* src/raptor_www.c: (raptor_www_error_varargs): Call
	raptor_log_error_varargs.

	* src/raptor_parse.c: (raptor_new_parser): Set locator and
	handlers/data in the error_handlers.
	(raptor_parser_fatal_error): Call raptor_log_error_varargs
	(raptor_parser_fatal_error_varargs): Removed.
	(raptor_parser_fatal_error_message_handler): call
	raptor_log_error.
	(raptor_parser_simple_error, raptor_parser_error_varargs,
	raptor_parser_warning): Call raptor_log_error_varargs.
	(raptor_parser_error_message_handler,
	raptor_parser_warning_message_handler): Call raptor_log_error.
	(raptor_set_fatal_error_handler, raptor_set_error_handler,
	raptor_set_warning_handler): Update for error_handlers
	(raptor_parser_copy_user_state): Copy raptor_error_handlers block.

	* src/raptor_sax2.c: (raptor_new_sax2): Just have error_handlers
	arg.  Use xmlSetStructuredErrorFunc for better libxml errors
	(raptor_sax2_set_locator): Removed, not needed.
	(raptor_sax2_simple_error): Call raptor_log_error_varargs.
	(raptor_sax2_parse_start): Call xmlSetStructuredErrorFunc
	(raptor_sax2_parse_chunk): Call raptor_log_error_simple instead of
	directly calling the error handler.

	* src/raptor_libxml.c: (raptor_libxml_call_handler): Removed.
	(raptor_libxml_warning, raptor_libxml_error_common,
	raptor_libxml_validation_warning): Use raptor_log_error_varargs.
	(raptor_libxml_xmlStructuredErrorFunc): Use locator from the
	error_handlers.  Call raptor_log_error.

	* src/raptor_general.c: (raptor_invoke_simple_message_varargs,
	raptor_invoke_message_varargs): Removed internal function.  Added
	raptor_log_level_labels list.
	(raptor_log_error_simple, raptor_log_error_varargs,
	raptor_log_error): Added for new logging.
	(raptor_error_handlers_init): Added to init new structure

	* src/raptor_internal.h: Added raptor_error_handlers structure and
	remove the pointers from raptor_parser, raptor_sax2.  Added
	raptor_log_level enum Removed raptor_invoke_message_varargs,
	raptor_invoke_simple_message_varargs Added
	raptor_error_handlers_init, void raptor_log_error_simple, void
	raptor_log_error_varargs, void raptor_log_error raptor_new_sax2
	now just takes a raptor_error_handler* param
	Removed raptor_sax2_set_locator

	* utils/rapper.c: help text for -t/--trace

2007-02-11  Dave Beckett <dave@dajobe.org>

	* src/raptor_libxml.c: #if LIBXML_VERSION >= not >

	* utils/rapper.1: Added -t/--trace option to show URIs traversed.

	* utils/rapper.c: Added -t/--trace option to show URIs traversed.
	(rapper_uri_trace): Added.
	(main): If tracing, register rapper_uri_trace as a URI filter
	function with raptor_parser_set_uri to see URis retrieved.

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Call
	xmlSetStructuredErrorFunc to make most errors be printed much nicer.

	* src/raptor_internal.h: Added
	raptor_libxml_xmlStructuredErrorFunc prototype.

	* src/raptor_libxml.c: (raptor_libxml_xmlStructuredErrorFunc):
	Added for sending libxml structured error messages back to a
	parser.

2007-02-10  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: Add XInclude headers
	(raptor_grddl_filter_triples): Renamed from
	raptor_grddl_relay_triples
	(raptor_grddl_filter_triples): Do not pass on triples, just look
	for transformation triples.
	(raptor_grddl_ensure_internal_parser): Add filter arg and if set
	for profile and namespace parsings, send triples via
	raptor_grddl_filter_triples.
	(raptor_grddl_run_grddl_transform_doc): Call
	raptor_grddl_ensure_internal_parser with no filtering when have
	got the resulting string and want to do a specific parse, not a
	recursive GRDDL.
	(raptor_grddl_run_recursive): Call
	raptor_grddl_ensure_internal_parser filtering when doing a
	recursive GRDDL - this is namespace or profile recursion.
	(raptor_grddl_parse_chunk): Run XML include processing.  Do not
	try to call NULL profile URIs.  Fix transformation loop to call
	all transformations, not just first.

	* src/raptor_grddl.c: (raptor_grddl_libxml_discard_error): Added
	to throw away libxml errors.
	(raptor_grddl_parse_chunk): Use raptor_grddl_libxml_discard_error
	to dicard XML validation errors since it seems the GRDDL spec
	doesn't care.

	* src/turtle_parser.y: (raptor_turtle_parse_recognise_syntax):
	Recognise n3 in mime type when N3 parser is not around.
	(raptor_turtle_parser_register_factory): Register low interest in
	text/rdf+n3 when N3 parser is not around.

2007-02-06  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_grddl_parse_chunk): Tidy up doc and
	xpath context on errors or success so that it is initialised next
	time for new documents.

	* src/raptor_grddl.c: (raptor_grddl_parser_add_parent): Do not set
	parent twice

2007-01-31  Dave Beckett <dave@dajobe.org>

	* configure.ac, src/win32_raptor_config.h: Bumped version to
	1.4.15

	* Snapshotted raptor_1_4_14 for 1.4.14 release (SVN r11863)

2007-01-28  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: (raptor_libxslt_error_common): Added.
	(raptor_grddl_xsltGenericError_handler): Added.
	(raptor_grddl_parse_init): Register
	raptor_grddl_xsltGenericError_handler to handle XSLT generic
	errors.
	(raptor_grddl_run_grddl_transform_doc): Set 'base' and 'Base' XSLT
	parameters to allow some XSLT sheets to work - pragmatism.

	* src/raptor_grddl.c: struct raptor_grddl_parser_context_s gains
	rdf_parser field.  Add lots more debugging messages
	(raptor_grddl_parse_init): Init rdf_parser field.
	(raptor_grddl_parser_add_parent): Relay all triples to the parent
	grddl parser.
	(raptor_grddl_ensure_internal_parser): Lose relay flag - always
	relay.
	(raptor_grddl_parse_chunk): Copy root_ns_uri if not NULL.  When
	processing head profile URIs, strip out the GRDDL profile URI
	before adding them to the grddl_parser->profile_uris sequence.

2007-01-27  Dave Beckett <dave@dajobe.org>

	* configure.ac: Add AC_CHECK_FUNC(xsltInit)

	* src/raptor_grddl.c: (raptor_init_parser_grddl): Check for xsltInit

	* src/raptor_parse.c: (raptor_parsers_finish): Call
	raptor_terminate_parser_grddl when enabled.

	* src/raptor_internal.h: Added raptor_terminate_parser_grddl prototype

	* src/raptor_grddl.c: Add XML schema namespace to ignored
	namespace list.
	(raptor_grddl_parse_chunk): Copy root namespace URI when adding to
	a list.
	(raptor_terminate_parser_grddl): Added, to free up shared
	resources.

	* docs/libraptor.3: 1.4.14

	* src/raptor_parse.c: autodocs

	* src/raptor_internal.h: Move raptor_turtle_writer to
	raptor_internal.h for now.

	* src/raptor.h: Move raptor_turtle_writer to raptor_internal.h for
	now.

2007-01-26  Dave Beckett <dave@dajobe.org>

	* src/n3_parser.y, src/ntriples_parse.c, src/raptor_general.c,
	src/raptor_rdfxml.c, src/raptor_rss.c, src/turtle_parser.y: Rename
	raptor_generate_id to raptor_parser_internal_generate_id with
	altered calling convention - pass in ID type

	* src/raptor.h: Adedd prototype for raptor_parser_generate_id

	* src/raptor_internal.h: raptor_parser_internal_generate_id
	renamed from raptor_generate_id.

	* src/raptor_parse.c: (raptor_parser_generate_id): Added as a
	public function, modified from previously internal
	raptor_generate_id().
	(raptor_parser_internal_generate_id): Renamed from
	raptor_generate_id.

2007-01-16  Dave Beckett <dave@dajobe.org>

	* utils/rapper.c: Add a another raptor_finish() before exit

2007-01-14  Dave Beckett <dave@dajobe.org>

	* src/raptor_grddl.c: struct raptor_grddl_parser_context_s loses
	xpathObj
	(raptor_grddl_parse_terminate): Remove xpathObj tidy.  Remove
	profile URIs from 'match_table' list of xpaths - now invoked on
	it's own.
	(raptor_grddl_relay_triples): Add relay triples debugging.  Fix
	loop to properly walk through profile URIs
	(raptor_grddl_run_xpath_match): Added to invoke a match to an
	xpath returning a list of URIs as raptor_sequence.  Code removed
	from raptor_grddl_parse_chunk.
	(raptor_grddl_run_recursive): Added to invoke a recursive GRDDL on
	a URI, sending triples back to the current parser.  Code removed
	from raptor_grddl_parse_chunk.
	(raptor_grddl_parse_chunk): Use raptor_grddl_run_recursive to do
	most of the work.  Invoke the <head profile> early on before
	running general XPath matches.  Use raptor_grddl_run_xpath_match
	to run general XPath matches.

	* utils/rapper.c: Use raptor_home_url_string and
	raptor_license_string in short and long usage messages.

	* src/raptor.h: Added raptor_home_url_string (replacing raptor_url)

	* src/raptor_general.c: raptor_home_url_string

	* src/raptor.h: Added raptor_url

	* src/raptor.h: Added raptor_license_string

	* src/raptor_general.c: 2007 and add raptor_license_string

2007-01-07  Dave Beckett <dave@dajobe.org>

	* src/raptor_abbrev.c: (raptor_new_abbrev_node): Initialise with
	ref_count 1
	(raptor_abbrev_node_lookup): Do not add ref_count here

	* tests/turtle/Makefile.am: (check-turtle-serialize): rdfdiff with
	a local file, not one in $(srcdir)

	* utils/rdfdiff.c: Apply the base URI to the to-file, if given.
	Otherwise use the from_file's URI.

	* tests/turtle/Makefile.am: (check-turtle-serialize): Add base
	URIs for the rdf-schema.ttl and rdfs-namespace.ttl

	* tests/turtle/Makefile.am: (check-turtle-serialize): Ensure it
	dies when a failure happens

	* tests/turtle/Makefile.am: (check-turtle-serialize): Call rdfdiff
	with -u to set base URI for input turtle.  This allows test-00.ttl
	to produce the same absolute URIs each time and for round-trip
	serializing to work.

	* utils/rdfdiff.c: Added -u/--base-uri option to specify the from
	file base URI so that if the from file is a local file or relative
	URI, it can be given an absolute base.

	* tests/turtle/Makefile.am: (check-turtle-serialize): output
	serialization results to .ttl files

	* tests/turtle/Makefile.am: Add check-turtle-serialize to
	check-local

2007-01-05  Dave Beckett <dave@dajobe.org>

	* src/raptor-config.1: Document --private-libs and explain what it
	is under --libs too.

	* src/raptor-config.in: Add --private-libs and move private @LIBS
	to that from --libs

	* raptor.pc.in: Use Libs.private for internal dynamically linked
	libraries
